#ifndef DEFINITIONS_C
#define DEFINITIONS_C


/*
 * SHCP_PIN - тактирование сдвигового регистра
 * STCP_PIN - тактирования для регистра вывода
 * DS_PIN   - порт последовательных данных
 */

#define SHCP_PIN 2
#define STCP_PIN 1
#define DS_PIN   0


// Установка в единицу бита BIT в регистре REG
#define PIN_SET(REG, BIT)         REG |= 1 << BIT

// Cброс в нуль бита BIT в регистре REG
#define PIN_CLEAR(REG, BIT)       REG &= ~(1 << BIT)

// Инвертировать бит BIT в регистре REG
#define PIN_INVERT(REG, BIT)      REG ^= 1 << BIT


// Отправить единицу на регистр
#define DATA_HIGH   PIN_SET(PORTB, DS_PIN)
// Отправить нуль на регистр
#define DATA_LOW    PIN_CLEAR(PORTB, DS_PIN)


// Послать импульс на ножку такрирования сдвигового регистра
#define SHIFT_CLOCK PIN_INVERT(PORTB, SHCP_PIN);\
                    PIN_INVERT(PORTB, SHCP_PIN)

// Послать импульс на ножку вывода
#define STATE_LOAD  PIN_INVERT(PORTB, STCP_PIN);\
                    PIN_INVERT(PORTB, STCP_PIN)


// unsigned char то же самое что и uchar
typedef unsigned char uchar;
// unsigned int то же самое что и uint
typedef unsigned int uint;


#endif // DEFINITIONS_C
